// $id$

// NOTE:
// Certain parameters are changed from SQL/human friendy to HTML friendly:
// SQL (ASC/DESC)  checkbox (TRUE/FALSE)...
function settingsHoist(settings) {
   this.cArray = new Array();
   // Strip waste values.
    for (var k in settings) {
      this.cArray[k] = new Array(settings[k].active, (settings[k].order == 'DESC'));
    }

  this.activeItem = function(item) {
    this.cArray[item][0] = true;
  }
  this.inactiveItem = function(item) {
    this.cArray[item][0] = false;
  }
  this.setOrder = function(item, o) {
    this.cArray[item][1] = o;
  }
  this.toStr = function() {
    // The space stops a display collapsing.
    // Mind you, that means later stripping it.
    // (css min-height: can't be trusted in IE, until IE7 ubiquitous.)
    var str = "&nbsp ";
    for (var key in this.cArray){
      if(this.cArray[key][0]) {
        str = str + key +' '+ (this.cArray[key][1] ? 'DESC' : 'ASC') +',  ';
      };
    }
    return str;
  }
}


var sortCboxIDRoot = "edit-taxonomy-treemenu-options-tab1-sort-options-";
var sortValID = "edit-taxonomy-treemenu-options-tab1-tab1-display";
var sortDID = "tab1_display";


function ttRefreshDisplay() {
  document.getElementById(sortValID).value = ttSortSettings.toStr();
  document.getElementById(sortDID).innerHTML = ttSortSettings.toStr();
}

function ttOrderWrapIDtoKey(wrapID) {
  return wrapID.substr(wrapID.lastIndexOf("-") + 1);
}
function ttSetSortOrder(valueID, v) {
  //alert('callback: ' + valueID);
  ttSortSettings.setOrder(valueID, v);
  ttRefreshDisplay();
}

function ttSetSortValue(v, checked) {
  //alert('callback: ' + v);
  //alert('callback: ' + checked);
  if(checked) {
    ttSortSettings.activeItem(v);
  }
  else{
    ttSortSettings.inactiveItem(v);
  }
  ttRefreshDisplay();
}

// Document Ready
$(document).ready(function() {

   // Initialise sort data set.
   ttSortSettings = new settingsHoist(Drupal.settings.ttPrefs.sort);

   // Click events for order functions.
   $(".tt-sort-order-asc").click(function () {
      // We won't waste jQuery on this!
      node = $(this)[0];
      node.className = "tt-sort-order-asc blue";
      topSpan = node.parentNode;
      topSpan.lastChild.className = "tt-sort-order-desc black";
      ttSetSortOrder(ttOrderWrapIDtoKey(topSpan.id), 0);
    });

   $(".tt-sort-order-desc").click(function () {
      // We won't waste jQuery on this!
      node = $(this)[0];
      node.className = "tt-sort-order-desc blue";
      topSpan = node.parentNode;
      topSpan.firstChild.className = "tt-sort-order-asc black";
      ttSetSortOrder(ttOrderWrapIDtoKey(topSpan.id), 1);
    });

    // Click event on checkboxes.
   $("#edit-taxonomy-treemenu-options-tab1").find("input").change(function () {
     ttSetSortValue($(this)[0].value, $(this)[0].checked);
    });

   // Set user display checkboxes, from Drupal settings data.
   jQuery.each(Drupal.settings.ttPrefs.sort, function(key, val) {
     if(this.active) {
      document.getElementById(sortCboxIDRoot + key).checked = true;
     }
     else{
       // Everything else unsets itself on a refresh, but checkboxes sustain,
       // so assert them blank.
       document.getElementById(sortCboxIDRoot + key).checked = false;
     }
    });
    
    // Refresh the user display and hidden value.
    ttRefreshDisplay();
});
